config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resource :dashboard, only: [:show]
  root 'static_pages#index'
  get 'privacy', to: 'static_pages#privacy'
  get 'careers', to: 'static_pages#careers'
  get 'team', to: 'static_pages#team'
  resources :courses, only: [:index, :show] do
    resources :enrollments, only: :create
  end
  resources :lessons, only: [:show]
  namespace :instructor do
    resources :lessons, only: [:update]
    resources :sections, only: [:update] do
      resources :lessons, only: [:create]
    end
    resources :courses, only: [:new, :create, :show] do
      resources :sections, only: [:create]
    end
  end
end
# For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/course.rb
class Course < ApplicationRecord
  mount_uploader :image, ImageUploader
  belongs_to :user
  has_many :sections
  has_many :enrollments

  validates :title, presence: true
  validates :description, presence: true
  validates :cost, presence: true, numericality: {greater_than_or_equal_to: 0}
  validates :image, presence: true

  def free?
    cost.zero?
  end

  def premium?
    ! free?
  end
end

app/models/enrollment.rb
class Enrollment < ApplicationRecord
  belongs_to :course
  belongs_to :user
end

app/models/lesson.rb
class Lesson < ApplicationRecord
  belongs_to :section
  mount_uploader :video, VideoUploader

  include RankedModel
  ranks :row_order, with_same: :section_id

  def next_lesson
    lesson = section.lessons.where("row_order > ?", self.row_order).rank(:row_order).first
    if lesson.blank? && section.next_section
      return section.next_section.lessons.rank(:row_order).first
    end
    return lesson
  end
end

app/models/section.rb
class Section < ApplicationRecord
  belongs_to :course
  has_many :lessons

  include RankedModel
  ranks :row_order, with_same: :course_id

  def next_section
    section = course.sections.where("row_order > ?", self.row_order).rank(:row_order).first
    return section
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :courses
  has_many :enrollments
  has_many :enrolled_courses, through: :enrollments, source: :course

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  def enrolled_in?(course)
    return enrolled_courses.include?(course)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/courses_controller.rb
class CoursesController < ApplicationController
  def index 
    @courses = Course.all
  end

  def show
    @course = Course.find(params[:id])
  end
end

app/controllers/dashboards_controller.rb
class DashboardsController < ApplicationController
  before_action :authenticate_user!

  def show
    
  end
end

app/controllers/enrollments_controller.rb
class EnrollmentsController < ApplicationController
  before_action :authenticate_user!

    def create
      if current_course.premium?
   
      # Amount in cents
      @amount = (current_course.cost * 100).to_i

      customer = Stripe::Customer.create(
        email: params[:stripeEmail],
        source: params[:stripeToken]
      )

      charge = Stripe::Charge.create(
        customer: customer.id,
        amount: @amount,
        description: 'Flixter Premo Content',
        description: 'Rails Stripe customer',
        currency: 'usd'
      )
      end
      current_user.enrollments.create(course: current_course)
      redirect_to course_path(current_course)
      rescue Stripe::CardError => e
        flash[:error] = e.message
        redirect_to root_path
      end 

      private

      def current_course
        @current_course ||= Course.find(params[:course_id])
      end
end

app/controllers/lessons_controller.rb
class LessonsController < ApplicationController

  before_action :authenticate_user!
  before_action :require_current_user_enrolled

  def show

  end

  def require_current_user_enrolled
    if ! current_user.enrolled_in?(current_lesson.section.course)
      redirect_to course_path(current_lesson.section.course), alert: 'Must Enroll To See Lessons'
    end
  end

  private 

  helper_method :current_lesson
  def current_lesson
    @current_lesson ||= Lesson.find(params[:id])
  end
end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController

  def index

  end
  

  def privacy

  end

  def careers

  end

  def team

  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/courses_helper.rb
module CoursesHelper
end

app/helpers/dashboards_helper.rb
module DashboardsHelper
end

app/helpers/enrollments_helper.rb
module EnrollmentsHelper
end

app/helpers/instructor/courses_helper.rb
module Instructor::CoursesHelper
end

app/helpers/instructor/lessons_helper.rb
module Instructor::LessonsHelper
end

app/helpers/lessons_helper.rb
module LessonsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Flixter</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    <link href="http://vjs.zencdn.net/5.12.6/video-js.css" rel="stylesheet">
  </head>

  <body>
    <div id="flex-content-container">
      <nav class="navbar navbar-toggleable-md navbar-inverse bg-inverse">
        <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
        </button>
        <a class="navbar-brand" href= / >Flixter</a>

        <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
        <ul class="navbar-nav mr-auto mt-2 mt-md-0">
          <li class="nav-item">
            <%= link_to 'See All Courses', courses_path, class: 'nav-link' %>
          </li>
        </ul>
        <ul class="navbar-nav">
          <% if user_signed_in? %>

            <li class="nav-item">
              <%= link_to 'My Dashboard', dashboard_path, class: 'nav-link' %>
            </li>

            <li class="nav-item">
               <%= link_to 'Sign Out', destroy_user_session_path, method: :delete, class: 'nav-link' %>
            </li>

          <% else %>

            <li class="nav-item">
              <%= link_to 'Sign In', new_user_session_path, method: :get, class: 'nav-link' %>
            </li>

            <li class="nav-item">
              <%= link_to 'Sign-Up', new_user_registration_path, class: 'nav-link' %>
            </li>

          <% end %>
        </ul>
        <form class="form-inline my-2 my-lg-0">
          <input class="form-control mr-sm-2" type="text" placeholder="Search">
          <button class="btn btn-secondary btn-xs" type="submit">Search</button>
        </form>
      </div>
    </nav>

      <% if notice.present? %>
        <p class="alert alert-info"><%= notice %></p>
      <% end %>
      <% if alert.present? %>
        <p class="alert alert-danger"><%= alert %></p>
      <% end %>


      <%= yield %>
    </div>

     <div id="footer">
      <div class="container">
       <div class="row">
      <div class="col-12 col-sm-3">
        <b>Instructors</b>
        <br />
        <%= link_to 'Instruct a Course', new_instructor_course_path %>
        <br />
        <%= link_to 'My Dashboard', dashboard_path %>
      </div>
      <div class="col-12 col-sm-3">
        <b>About</b>
        <br />
        <%= link_to 'Team', team_path %>        <br />
        <%= link_to 'Careers', careers_path %>
        <br />
        <%= link_to 'Privacy Policy', privacy_path %>
      </div>
      <div class="col-12 col-sm-3">
        <b>Contact</b>
        <br />
        that@gmail.com
        <br />
        yuh kanui circle
        <br />
        mm hmm
      </div>
      <div class="col-12 col-sm-3 social">
        <b>Social</b>
        <br />
        <%= link_to 'https://github.com/kanui624' do %>
          <span class="fa fa-github-square fa-2x social-button"></span>
        <% end %>
          <span class="fa fa-facebook-square fa-2x social-button"></span>
          <span class="fa fa-twitter-square fa-2x social-button"></span>
      </div>
    </div>
    <script src="http://vjs.zencdn.net/5.12.6/video.js"></script>
    <script src="http://vjs.zencdn.net/ie8/1.1.2/videojs-ie8.min.js"></script>
  </body>
</html>